Use cgimap from PPA rather than building from source.
authorMatt Amos <zerebubuth@gmail.com>
Mon, 20 Jun 2016 17:53:00 +0000 (18:53 +0100)
committerMatt Amos <zerebubuth@gmail.com>
Mon, 3 Oct 2016 12:46:36 +0000 (13:46 +0100)
cookbooks/apt/recipes/default.rb
cookbooks/web/attributes/default.rb
cookbooks/web/metadata.rb
cookbooks/web/recipes/base.rb
cookbooks/web/recipes/cgimap.rb
cookbooks/web/recipes/gpx.rb
cookbooks/web/recipes/nfs.rb [new file with mode: 0644]
cookbooks/web/recipes/rails.rb
cookbooks/web/templates/default/cgimap.init.erb [new file with mode: 0644]

index 74766e6..7fe4d80 100644 (file)
@@ -130,6 +130,11 @@ apt_source "mediawiki" do
   key "90E9F83F22250DD7"
 end
 
+apt_source "openstreetmap-cgimap" do
+  url "http://ppa.launchpad.net/zerebubuth/openstreetmap-cgimap/ubuntu"
+  key "CDADED50"
+end
+
 package "unattended-upgrades"
 
 if Dir.exist?("/usr/share/unattended-upgrades")
index 8ad59e5..540ec54 100644 (file)
@@ -1,3 +1,6 @@
 default[:web][:base_directory] = "/srv/www.openstreetmap.org"
 default[:web][:pid_directory] = "/var/run/web"
 default[:web][:log_directory] = "/var/log/web"
+
+# need the APT source for cgimap to be able to install the package
+default[:apt][:sources] = node[:apt][:sources] | ["openstreetmap-cgimap"]
index 5058ffb..a0dc45f 100644 (file)
@@ -4,7 +4,7 @@ maintainer_email  "admins@openstreetmap.org"
 license           "Apache 2.0"
 description       "Installs and configures www.openstreetmap.org servers"
 long_description  IO.read(File.join(File.dirname(__FILE__), "README.md"))
-version           "1.0.0"
+version           "1.0.1"
 depends           "apache"
 depends           "passenger"
 depends           "git"
@@ -12,3 +12,5 @@ depends           "memcached"
 depends           "nodejs"
 depends           "tools"
 depends           "nfs"
+depends           "accounts"
+depends           "apt"
index 6b70cb7..28bcf76 100644 (file)
 # limitations under the License.
 #
 
-node.default[:nfs]["/store/rails"] = {
-  :host => node[:web][:fileserver],
-  :path => "/store/rails"
-}
-
-include_recipe "nfs"
-
 directory node[:web][:base_directory] do
   group "rails"
   mode 0o2775
index 2adb9d0..a761f6f 100644 (file)
@@ -22,98 +22,14 @@ include_recipe "web::base"
 
 db_passwords = data_bag_item("db", "passwords")
 
-package "g++"
-package "gcc"
-package "make"
-package "autoconf"
-package "automake"
-package "libtool"
-package "libfcgi-dev"
-package "libxml2-dev"
-package "libmemcached-dev"
-package "libboost-regex-dev"
-package "libboost-system-dev"
-package "libboost-program-options-dev"
-package "libboost-date-time-dev"
-package "libboost-filesystem-dev"
-package "libpqxx-dev"
-package "zlib1g-dev"
+package "openstreetmap-cgimap-bin"
 
-cgimap_directory = "#{node[:web][:base_directory]}/cgimap"
-pid_directory = node[:web][:pid_directory]
-log_directory = node[:web][:log_directory]
-
-execute "cgimap-build" do
-  action :nothing
-  command "make"
-  cwd cgimap_directory
-  user "rails"
-  group "rails"
-end
-
-execute "cgimap-configure" do
-  action :nothing
-  command "./configure --with-fcgi=/usr --with-boost-libdir=/usr/lib/x86_64-linux-gnu"
-  cwd cgimap_directory
-  user "rails"
-  group "rails"
-  notifies :run, "execute[cgimap-build]", :immediate
-end
-
-execute "cgimap-autogen" do
-  action :nothing
-  command "./autogen.sh"
-  cwd cgimap_directory
-  user "rails"
-  group "rails"
-  notifies :run, "execute[cgimap-configure]", :immediate
-end
-
-git cgimap_directory do
-  action :sync
-  repository "git://git.openstreetmap.org/cgimap.git"
-  revision "live"
-  user "rails"
-  group "rails"
-  notifies :run, "execute[cgimap-autogen]", :immediate
-end
-
-if node[:web][:readonly_database_host]
-  database_host = node[:web][:readonly_database_host]
-  database_readonly = true
-else
-  database_host = node[:web][:database_host]
-  database_readonly = node[:web][:status] == "database_readonly"
-end
-
-memcached_servers = node[:web][:memcached_servers]
-
-cgimap_init = edit_file "#{cgimap_directory}/scripts/cgimap.init" do |line|
-  line.gsub!(/^CGIMAP_HOST=.*;/, "CGIMAP_HOST=#{database_host};")
-  line.gsub!(/^CGIMAP_DBNAME=.*;/, "CGIMAP_DBNAME=openstreetmap;")
-  line.gsub!(/^CGIMAP_USERNAME=.*;/, "CGIMAP_USERNAME=rails;")
-  line.gsub!(/^CGIMAP_PASSWORD=.*;/, "CGIMAP_PASSWORD=#{db_passwords['rails']};")
-  line.gsub!(/^CGIMAP_PIDFILE=.*;/, "CGIMAP_PIDFILE=#{pid_directory}/cgimap.pid;")
-  line.gsub!(/^CGIMAP_LOGFILE=.*;/, "CGIMAP_LOGFILE=#{log_directory}/cgimap.log;")
-  line.gsub!(/^CGIMAP_MEMCACHE=.*;/, "CGIMAP_MEMCACHE=#{memcached_servers.join(',')};")
-  line.gsub!(/^CGIMAP_RATELIMIT=.*;/, "CGIMAP_RATELIMIT=204800;")
-
-  line.gsub!(%r{--pidfile \$CGIMAP_PIDFILE --exec /home/rails/bin/openstreetmap-cgimap}, "--pidfile $CGIMAP_PIDFILE")
-
-  line.gsub!(%r{/home/rails/bin/openstreetmap-cgimap}, "#{cgimap_directory}/openstreetmap-cgimap")
-
-  if database_readonly
-    line.gsub!(/--daemon/, "--daemon --readonly")
-  end
-
-  line
-end
-
-file "/etc/init.d/cgimap" do
+template "/etc/init.d/cgimap" do
   owner "root"
   group "root"
   mode 0o755
-  content cgimap_init
+  source "cgimap.init.erb"
+  variables :db_password => db_passwords['rails']
 end
 
 if %w(database_offline api_offline).include?(node[:web][:status])
@@ -124,7 +40,7 @@ else
   service "cgimap" do
     action [:enable, :start]
     supports :restart => true, :reload => true
-    subscribes :restart, "execute[cgimap-build]"
+    subscribes :restart, "dpkg_package[openstreetmap-cgimap-bin]"
     subscribes :restart, "file[/etc/init.d/cgimap]"
   end
 end
index 7806530..791c3fe 100644 (file)
@@ -18,6 +18,7 @@
 #
 
 include_recipe "web::base"
+include_recipe "web::nfs"
 
 db_passwords = data_bag_item("db", "passwords")
 
diff --git a/cookbooks/web/recipes/nfs.rb b/cookbooks/web/recipes/nfs.rb
new file mode 100644 (file)
index 0000000..1ca1312
--- /dev/null
@@ -0,0 +1,25 @@
+#
+# Cookbook Name:: web
+# Recipe:: nfs
+#
+# Copyright 2011, OpenStreetMap Foundation
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#     http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+
+node.set[:nfs]["/store/rails"] = {
+  :host => node[:web][:fileserver],
+  :path => "/store/rails"
+}
+
+include_recipe "nfs"
index 52aa096..848ac23 100644 (file)
@@ -19,6 +19,7 @@
 
 include_recipe "tools"
 include_recipe "web::base"
+include_recipe "web::nfs"
 
 include_recipe "apache"
 include_recipe "passenger"
diff --git a/cookbooks/web/templates/default/cgimap.init.erb b/cookbooks/web/templates/default/cgimap.init.erb
new file mode 100644 (file)
index 0000000..a2b25d2
--- /dev/null
@@ -0,0 +1,56 @@
+#!/bin/bash
+
+<%
+pid_directory = node[:web][:pid_directory]
+log_directory = node[:web][:log_directory]
+
+if node[:web][:readonly_database_host]
+  database_host = node[:web][:readonly_database_host]
+  database_readonly = true
+else
+  database_host = node[:web][:database_host]
+  database_readonly = node[:web][:status] == "database_readonly"
+end
+
+memcached_servers = node[:web][:memcached_servers] || []
+%>
+
+CGIMAP_HOST=<%= database_host %>; export CGIMAP_HOST
+CGIMAP_DBNAME=openstreetmap; export CGIMAP_DBNAME
+CGIMAP_USERNAME=rails; export CGIMAP_USERNAME
+CGIMAP_PASSWORD=<%= @db_password %>; export CGIMAP_PASSWORD
+
+CGIMAP_PIDFILE=<%= pid_directory + "/cgimap.pid" %>; export CGIMAP_PIDFILE
+CGIMAP_LOGFILE=<%= log_directory + "/cgimap.log" %>; export CGIMAP_LOGFILE
+
+CGIMAP_MEMCACHE=<%= memcached_servers.join(",") %>; export CGIMAP_MEMCACHE
+CGIMAP_RATELIMIT=204800; export CGIMAP_RATELIMIT
+CGIMAP_MAXDEBT=250; export CGIMAP_MAXDEBT
+
+start() {
+  start-stop-daemon --start --chuid rails --exec /usr/bin/openstreetmap-cgimap -- --daemon --port=8000 --instances=30 --pidfile $CGIMAP_PIDFILE
+}
+
+stop() {
+  start-stop-daemon --stop --retry 300 --pidfile $CGIMAP_PIDFILE
+}
+
+reload() {
+  start-stop-daemon --stop --signal HUP --pidfile $CGIMAP_PIDFILE
+}
+
+case "$1" in
+  start)
+    start
+    ;;
+  stop)
+    stop
+    ;;
+  reload)
+    reload
+    ;;
+  restart)
+    stop || exit $?
+    start
+    ;;
+esac